<!DOCTYPE html>
<html lang="de">
	<head>
		<meta charset="utf-8" />
		<title>jQuery</title>
		<link rel="icon" href="../HSR.Template.Exercises/icon-document.png" type="image/png">

		<link rel="stylesheet" type="text/css" href="../HSR.Template.Exercises/documentStyle.css">
		<script src="../HSR.Template.Exercises/solutions.js"></script>
		<script src="https://cdn.rawgit.com/google/code-prettify/master/loader/run_prettify.js"></script>
		<style>
			td{
				text-align: left;
			}
		</style>
	</head>
	<body>
		<h1>
			<a class="backlink" href="../index.html">⇦</a>
			jQuery
			<button id="showSolutions">Lösungen anzeigen/ausblenden</button>
		</h1>

		<h2>Theorie</h2>
		<p>Als Nachschlagewerk nutzen Sie die jQuery Dokumentation unter <a target="_blank" href="http://learn.jquery.com/">http://learn.jquery.com/</a>.</p>

		<h2>Aufgabe A - jQuery richtig einbinden.</h2>
		<p class="description">Nachfolgend sollte mit jQuery ein Text gesetzt werden. Was läuft schief? Korrigieren Sie dieses Problem auf zwei verschiedene Arten direkt im HTML.</p>
		<div class="solution">
			<p>Problem: jQuery ist wird erst nach dem Script Tag eingebunden und der DOM ist nicht aufgebaut.</p>
			<a href="solutions/jquery-einbinden.html">Lösung</a>
			<p>Variante 1 und 2 sind als Kommentare im HTML definiert.</p>
		</div>

		<script>$("#toChange").text("Wurde geändert")</script>
		<div id="toChange"><strong>Dieser Text sollte geändert werden.</strong></div>

		<h2>Aufgabe B - Conflict</h2>
		<p class="description">Lesen sie folgendes Kapitel: <a target="_blank" href="http://api.jquery.com/jquery.noconflict/">http://api.jquery.com/jquery.noconflict/</a>.
			<br/>Folgendes HTML ist so konfiguriert das ein jQuery konflikt entsteht.
			Finden Sie diesen und korrigieren Sie diesen. Halten Sie sich dabei an die Richtlinien die jQuery vorschlägt.
			<a target="_blank" href="files/uebungB.html">Übung B</a>.
		</p>
		<div class="solution">
			<a href="solutions/aufgabeB_loesung.js">Lösung</a>
		</div>

		<script src="jquery-1.12.3.min.js"></script>

		<h2>Aufgabe C - Input</h2>
		<p class="description">Nachfolgend ist ein Input Feld gegeben. Bei einem [ENTER] sollte der Text beim vorgesehenem div hinzugefügt werden. Ebenso beim bestätigen des Send Buttons.
			<br> Nutzen Sie das File files/aufgabeC.js für Ihre Lösung.
		</p>
		<form>
			<input id="input">
			<input type="button" value="Send" id="send">
		</form>

		<div id="sendContainer"></div>
		<script src="files/aufgabeC.js"></script>

		<div class="solution">
			<a href="solutions/aufgabeC_Loesung.js">Lösung</a>
		</div>

		<h2>Selektoren</h2>
		<p class="description">Die Ausgangslage für diese Aufgabe bildet das folgende <a target="_blank" href="files/selektoren.html">Html-Dokument</a>.
			Öffnen Sie das Html-Dokument in der Developer Console und versuchen Sie die folgenden Boxen mithilfe der jQuery Dokumentation auszufüllen. Falls das Resultat vorgeben ist, vervollständigen
			Sie den Selektor damit das definierte Resultat zurückgegeben wird. Überprüfen Sie im Anschluss Ihre Lösung mit der Ausgabe auf der Konsole im oben beschriebenen HTML.
		</p>

		<table>
			<thead>
			<tr>
				<th>jQuery Selektor</th>
				<th>Ausgabe</th>
			<tr>
			<thead>
			<tbody>
			<tr>
				<td>$('#head > title').text()</td>
				<td><input type="text" /></td>
			</tr>
			<tr>
				<td>$('<input type="text" />').first().text()</td>
				<td>$1</td>
			</tr>
			<tr>
				<td>$('tr').length</td>
				<td><input type="text" /></td>
			</tr>
			<tr>
				<td>$('#age').val()+10</td>
				<td><input type="text" /></td>
			</tr>
			<tr>
				<td>(function() { if($('#sex').val()) { return "t"; } else { return "f"; } })()</td>
				<td><input type="text" /></td>
			</tr>
			<tr>
				<td>typeof($('#age2').val()-7)</td>
				<td><input type="text" /></td>
			</tr>
			<tr>
				<td>typeof($('#sex').html)</td>
				<td><input type="text" /></td>
			</tr>
			<tr>
				<td>$('#th > td').text()</td>
				<td><input type="text" /></td>
			</tr>
			</tbody>
		</table>

		<div class="solution">
			<a href="solutions/selektoren.html">Lösung (console)</a>
		</div>

		<h2>DOM mit Whitespace</h2>
		<p>Nutzen Sie folgendes <a href="files/whitespace.html">files/whitespace.html</a><p>
		<p>Begründen Sie weshalb die 3 spans nicht auf eine Zeile passt obwohl allen offenslichen Probleme ausradiert wurden. (100% in der Summe & box-sizing gesetzt)</p>
		<p>
			Führen Sie folgende Befehle aus:
		</p>
		<ul>
			<li>document.body.childNodes</li>
			<li>document.body.childNodes[1].childNodes</li>
			<li>document.body.childNodes[1].childNodes[0]</li>
		</ul>
		<p>Finden Sie im Web zwei Lösung um dieses Problem zu lösen. Führen Sie nochmals die obigen Befehle aus. Was hat sich geändert?</p>
		<div class="solution">
			<a href="solutions/whitespace.html">Lösung (console)</a>
		</div>

		<h2>Performance</h2>
		<p class="description">Das folgende Code-Stück zeigt ein typisches jQuery Fragment.
			Finden Sie Optimierungsmöglichkeiten in Bezug auf die Performance.

		<p>
			<strong>Tipps:</strong>
		<ul>
			<li>Der jQuery Selektor ist relativ aufwändig.</li>
			<li>jQuery Funktionen können aneinander gehängt werden (function chaining).</li>
			<li>Die jQuery <a href="http://api.jquery.com/jquery/#jQuery1" target="_blank">Selektor-Funktion</a> unterstützt mehrere Argumente.</li>
		</ul>
		</p>

<pre class="prettyprint prettyprinted"><code>
$('#frmFeedback .submit').click(function() {
    $('#lblFormHeader').blur();
    $('#lblFormHeader').hide();
    $('#frmFeedback .state').css('background-color', 'red');
});	</code></pre>
		</p>

	<div class="solution">
<pre class="prettyprint prettyprinted"><code>
var feedbackForm = $('#frmFeedback');
$('.submit', feedbackForm).click(function() {
	$('#lblFormHeader').blur().hide();
	$('.state', feedbackForm).css('background-color', 'red');
});
</code></pre>
</p>

	</div>




	</body>
</html>
